# Copyright (C) 2018 Freetech Solutions

# This file is part of OMniLeads

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/.
#
---

- name: Installation of mariadb
  yum: name={{ item }} state=present
  with_items:
    - MySQL-python.x86_64
    - mariadb-server
  retries: 3
  delay: 3
  register: result
  until: result is success

# En estas tasks se hacen tareas de segurizacion de mariadb, es como hacer un mariadb-secure no voy a explicar una por una, nunca fallan
- name: Enable and start MariaDB (centos)
  service: name=mariadb enabled=yes state=started

- name: Remove .my.cnf
  file: path=/root/.my.cnf state=absent
  tags: postinstall

- name: Set root Password
  mysql_user: name=root host={{ mysql_host }} password={{ mysql_root_password }} login_host={{ mysql_host }} state=present update_password=always
  environment:
    MYSQL_HOST: "{{ mysql_host }}"
    MYSQL_PWD: "{{ mysql_old_root_password }}"
  when: mysql_root_password != ""

- name: Set MYSQL_PWD in omnileads_envars.sh
  blockinfile:
    path: /etc/profile.d/omnileads_envars.sh
    insertafter: EOF
    state: present
    block: |
      export MYSQL_PWD={{ mysql_root_password }}

- name: Reload privilege tables
  command: "mysql -ne \"FLUSH PRIVILEGES\""
  environment:
    MYSQL_HOST: "{{ mysql_host }}"
    MYSQL_PWD: "{{ mysql_root_password}}"
  changed_when: False

- name: Remove anonymous users
  command: "mysql -ne \"DELETE FROM mysql.user WHERE User=''\""
  changed_when: False
  environment:
    MYSQL_HOST: "{{ mysql_host }}"
    MYSQL_PWD: "{{ mysql_root_password}}"

- name: Disallow root login remotely
  command: "mysql -ne \"DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('{{ mysql_host }}')\""
  changed_when: False
  environment:
    MYSQL_HOST: "{{ mysql_host }}"
    MYSQL_PWD: "{{ mysql_root_password}}"

- name: Grant privileges to root mysql user
  command: "mysql -ne \"GRANT ALL PRIVILEGES ON *.* TO 'root'@'{{ mysql_host }}' IDENTIFIED BY '{{ mysql_root_password }}' WITH GRANT OPTION;\""
  environment:
    MYSQL_HOST: "{{ mysql_host }}"
    MYSQL_PWD: "{{ mysql_root_password}}"

- name: Enable and start MariaDB (centos)
  service: name=mariadb enabled=yes state=started
  become: true
  become_method: sudo
  when: ansible_os_family == "RedHat"
